#!/bin/sh
#/* Copyright (C) Perinet /*

OLD_DIR=`echo $(pwd)`
cd /var/pki

# Setup variables
EXPIRY_DAYS=10950
CA_NAME=pki2go-ecc-root-ca
CN=$1\ Root\ CA
ON=$1

# change pki2go-ecc-root-ca name in config file
sed -i -r "s|(commonName *= *\").*|\1$CN\"|" pki2go-ecc-root-ca.conf
sed -i -r "s|(organizationName *= *\").*|\1$ON\"|" pki2go-ecc-root-ca.conf
sed -i -r "s|(organizationName *= *\").*|\1$ON\"|" certificate.conf

# Remove ca folder if exists
rm -rf ca certs/ private/

# Create directory
mkdir -p ca/$CA_NAME/private ca/$CA_NAME/db certs private
chmod 700 ca/$CA_NAME/private

# Create database
touch ca/$CA_NAME/db/$CA_NAME.db
touch ca/$CA_NAME/db/$CA_NAME.db.attr

# Create serial
openssl rand -hex 16 > ca/$CA_NAME/db/$CA_NAME.crt.srl

# create tke key pair to CA
openssl ecparam -genkey -name prime256v1 -out ca/$CA_NAME/private/$CA_NAME.key

# Create the .csr to self sign the  
CN=$CA_NAME openssl req -new -config pki2go-ecc-root-ca.conf -out ca/$CA_NAME.csr -key ca/$CA_NAME/private/$CA_NAME.key

# self sign ca
CN=$CA_NAME openssl ca -selfsign -config pki2go-ecc-root-ca.conf -key ca/$CA_NAME/private/$CA_NAME.key -in ca/$CA_NAME.csr -out ca/$CA_NAME.crt -batch -extensions root_ca_ext

#copy root-ca
cp /var/pki/ca/pki2go-ecc-root-ca.crt /etc/webserver/root-ca.pem

cd $OLD_DIR