'use strict';

function init_dialogs()
{
	var infoDiag = `
		<div class="modalbg" id="infoDiag" style="display:none;">
			<div class="modalwarningImg">
				<img src="images/img_modal_warning.png" width="154" height="134"  alt=""/>
			</div>
			<div id="infoDiagText" class="modalmsg" >Default Text</div>
			<div class="modalbt">
				<input type="button" class="modal_bt gray" value="OK" onclick="$(\'#infoDiag\').fadeOut();">
			</div>
		</div>
	`;

	$( 'body' ).append( infoDiag );

	var confirmDiag = `
		<div class="modalbg" id="confirmDiag" style="display:none;">
			<div class="modalwarningImg">
				<img src="images/img_modal_warning.png" width="154" height="134"  alt=""/>
			</div>
			<div id="confirmDiagText" class="modalmsg" >Default Text</div>
			<div class="modalbt">
				<input type="button" class="modal_bt gray" value="OK" onclick="$(\'#confirmDiag\').fadeOut();fun_yes();">
				<input type="button" class="modal_bt gray" value="Cancel" onclick="$(\'#confirmDiag\').fadeOut();fun_no();">
			</div>
		</div>
	`;

	$( 'body' ).append( confirmDiag );

	var autoInfoDiag = `
		<div class="modalbg" id="autoInfoDiag" style="display:none;">
			<div class="modalwarningImg">
				<img src="images/img_modal_info.png" width="154" height="134"  alt=""/>
			</div>
			<div id="autoInfoDiagText" class="modalmsg" >Default Text</div>
		</div>
	`;

	$( 'body' ).append( autoInfoDiag );

	var loginDiag = `
		<div class="modalbg" id="loginDiag" style="display:none;">
			<div class="modalloginBG"><div class="loginlogo">
				<img src="images/logo_perinet_login.png" width="300" height="120"  alt=""/>
			</div>
			<div class="logintitle">System Login</div>
			<div class="loginmsg" id="loginmsg"><b>Please try again:</b><br>Password was not correct.</div>
			<form onsubmit="return false;">
				<div class="login_input">
					User
					<select class="LoginUser" id="login_user">
						<option value="admin" >admin</option>
						<option value="containeradmin">containeradmin</option>
						<option value="user">user</option>
					</select>
					<br>
					Password
					<input type="password" class="LoginPW" value="" id="login_pass">
				</div>

				<div class="loginbt" >
					<input id="login_button" type="submit" class="form_bt enabled" value="Login" onclick="login_handler.req()" >
				</div>
			</form>
			<div style="text-align:center;">
				<a href="api" class="resource" target="_blank" style="margin-right:30px;">Documentation</a>
				<a href="deviceinfo.html"  class="resource" target="_blank">Device Information</a>
			</div>
		</div>
	`;
	$( 'body' ).append( loginDiag );

	var checkBoxDiag = `
		<div class="modalbg" id="checkBoxDiag" style="display:none;width:500px;margin: 0 auto; background: lightgrey">
			<h3> The following devices are intended for this container.
				  Which devices do you want to make accessible for usage in this Container?
			</h3> 
			<div id="checkBoxDiagCnt" >Default Text</div>
			<div class="modalbt" id="checkBoxButton"></div>
		</div>
	`;
	$( 'body' ).append( checkBoxDiag );

	var progressDialog = `	
		<div class="modalbg" id="progressDialog" style="display:none;">
			<div class="progress-pie-chart" data-percent="63">
				<div class="ppc-progress">
					<div class="ppc-progress-fill"></div>
				</div>
				<div class="ppc-percents loading"></div>
				<div class="ppc-percents loaded"></div>
			</div>

			<div class="modalmsg" id="progressDiagText" >Installing New Container...</div>
		</div>
	`;
	$( 'body' ).append( progressDialog );


	$( 'body' ).append( custom_dialog.htmlcont );
	$( 'body' ).append( promised_custom_dialog.htmlcont );

	containername_dialog.init();
	containerselect_dialog.init();
	scriptexec_dialog.init();
	hostname_dialog.init();
	user_dialog.init();
	spinner.init();
}

var fun_yes = function() { alert( "yes" ) };
var fun_no = function() { alert( "no" ) };


function show_progress()
{
	set_progress( 0.0 );
	$( "#progressDialog" ).fadeIn();
}

function hide_progress()
{
	$( "#progressDialog" ).fadeOut();
}

function set_progress( p_cent )
{
	if( p_cent <= 0.5 )
		p_cent = 0.5

	p_cent = Math.min( 100, p_cent )

	var $ppc = $( '.progress-pie-chart' ),
		percent = parseFloat( p_cent ),
		deg = 360.0 * percent / 100.0;
	if( percent > 50.0 )
		$ppc.addClass( 'gt-50' );
	else
		$ppc.removeClass( 'gt-50' );
	$( '.ppc-progress-fill' ).css( 'transform', 'rotate(' + deg + 'deg)' );
	$( '.ppc-percents span' ).html( percent + '%' );
}



function show_login()
{
	$( "#login_button" ).show();
	$( '#login_user' ).val( 'admin' );
	$( '#login_pass' ).val( '' );
	$( "#loginmsg" ).hide();
	$( "#loginDiag" ).fadeIn();

	//$('#login_pass').val( 'admin' );
	//setTimeout( login_handler.req, 0 );
}

function hide_login()
{
	$( "html" ).off( "keypress" );
	$( "#loginDiag" ).fadeOut();
}



function auto_info_dialog( txt )
{
	$( "#autoInfoDiagText" ).html( txt );
}


function info_dialog( txt )
{
	$( "#infoDiagText" ).html( txt );
	$( '#infoDiag' ).fadeIn();
}


function confirm_dialog( txt, fn_yes, fn_no )
{
	fun_yes = fn_yes;
	fun_no = fn_no;
	$( "#confirmDiagText" ).html( txt );
	$( '#confirmDiag' ).fadeIn();
}

function checkbox_dialog( cnt, btn )
{

	$( '#checkBoxDiagCnt' ).html( cnt );
	$( '#checkBoxButton' ).html( '<input type="button" class="modal_bt gray" value="OK" onclick="' + btn + '">' );
	$( '#checkBoxDiag' ).fadeIn();
}

var custom_dialog =
{
	htmlcont: ''
		+ '<div class="modalbg" id="customDiag" style="display:none;">'
		+ '  <div class="modalwarningImg"><img src="images/img_modal_warning.png" width="154" height="134"  alt=""/></div>'
		+ '  <div id="customDiagText" class="modalmsg" >Default Text</div>'
		+ '	<div class="modalbt">'
		+ '		<input id="cd1" type="button" class="modal_bt gray" value="OK" onclick="$(\'#customDiag\').fadeOut();custom_dialog.fun1();">'
		+ '		<input id="cd2" type="button" class="modal_bt gray" value="Cancel" onclick="$(\'#customDiag\').fadeOut();custom_dialog.fun2();">'
		+ '	</div>'
		+ '</div>',

	fun1: function()
	{
		alert( "fun1" );
	},

	fun2: function()
	{
		alert( "fun2" );
	},

	set_button_text: function( b1, b2 )
	{
		$( "#cd1" ).prop( 'value', b1 );
		$( "#cd2" ).prop( 'value', b2 );
	},

	show: function( txt, f1, f2 )
	{
		this.fun1 = f1;
		this.fun2 = f2;
		$( "#customDiagText" ).html( txt );
		$( '#customDiag' ).fadeIn();
	}
}


var promised_custom_dialog =
{
	htmlcont: ''
		+ '<div class="modalbg" id="pCustomDiag" style="display:none;">'
		+ '  <div class="modalwarningImg"><img src="images/img_modal_warning.png" width="154" height="134"  alt=""/></div>'
		+ '  <div id="pCustomDiagText" class="modalmsg" >Default Text</div>'
		+ '	<div class="modalbt">'
		+ '		<input id="cd142_true" type="button" class="modal_bt gray" value="OK" >'
		+ '		<input id="cd142_false" type="button" class="modal_bt gray" value="Cancel">'
		+ '	</div>'
		+ '</div>',

	resolve: () => { },

	reject: () => { },

	set_button_text: function( b1, b2 )
	{
		$( "#cd142_true" ).prop( 'value', b1 );
		$( "#cd142_false" ).prop( 'value', b2 );
	},

	show: function( txt )
	{
		let _ = this;
		$( "#cd142_true" ).click(
			function()
			{
				_.resolve( true );
				$( "#pCustomDiag" ).fadeOut();
			}
		);
		$( "#cd142_false" ).click(
			function()
			{
				_.resolve( false );
				$( "#pCustomDiag" ).fadeOut();
			}
		);

		$( "#pCustomDiagText" ).html( txt );
		return new Promise(
			( resolve, reject ) =>
			{
				this.resolve = resolve;
				this.reject = reject;

				$( '#pCustomDiag' ).fadeIn();
			}
		);
	}
}


var containername_dialog =
{
	validated: false
	,
	sid: s_id()
	,
	htmlcont: function()
	{
		return `
			<div class="modaltransparent" id="diag_${this.sid}" style="display:none;">
				<div class="modalinput3" >
					<div class="modalcentered">						
						<div id="customDiagText">
							<div id="getvaltxt" style="margin-bottom:15px;">...</div>
							Container Name: <input type="text" class="contentfield" style="" id="cn_${this.sid}" value="" autofocus>
							<div style="position:relative;margin-top:30px;text-align:right;">
								<input style="height:38px;" id="inp_ab_${this.sid}" type="button" class="modal_bt gray" value="Abort">
								<input style="height:38px;" id="inp_cnt_${this.sid}" type="button" class="modal_bt gray" value="Continue" >
							</div>
						</div>
					</div>
				</div>
			</div>`
	}
	,
	validator_func: function() { }
	,
	show_as_promise: function( text, validator_func )
	{
		return new Promise(
			( resolve, reject ) =>
			{
				this.prom_resolve = resolve;
				this.prom_reject = reject;

				this.validated = false;
				this.validator_func = validator_func;

				let value = "#cn_" + this.sid;
				$( value ).val( "" );
				$( "#getvaltxt" ).html( text );
				document.getElementById( "cn_" + this.sid ).focus();

				$( "#diag_" + this.sid ).fadeIn();
			}
		);
	}
	,
	prom_resolve: () => { }
	,
	prom_reject: () => { }
	,
	init: function()
	{
		let _ = this;

		$( 'body' ).append( _.htmlcont() );

		let inp_cnt_id_sel = "#inp_cnt_" + _.sid;
		let inp_abort_id_sel = "#inp_ab_" + _.sid;
		let n = "#diag_" + _.sid;
		let value = "#cn_" + _.sid;

		$( inp_cnt_id_sel ).click(
			async function()
			{
				let v = await _.validate();
				if( v )
				{
					_.prom_resolve( $( "#cn_" + _.sid ).val() );
					$( "#diag_" + _.sid ).fadeOut();
				}

			}
		);

		$( inp_abort_id_sel ).click(
			function()
			{
				_.prom_reject();
				$( n ).fadeOut();
			}
		);
		$( value ).blur(
			function()
			{
				//_.validate();
			}
		);
	}
	,
	validate: async function()
	{
		let v = await this.validator_func( $( "#cn_" + this.sid ).val() );
		return v;
	}
}


var containerselect_dialog =
{
	sid: s_id()
	,
	htmlcont: function()
	{
		return `
			<div class="modaltransparent" id="diag_${this.sid}" style="display:none;">
				<div class="modalinput3" >
					<div class="modalcentered">						
						<div id="customDiagText">
							<div id="getvaltxt__" style="margin-bottom:15px;">...</div>
							Container Name:
                     <select class="contentselect" style="" id="cn_${this.sid}" >
                     </select>
							<div style="position:relative;margin-top:10px;text-align:right;">
								<input style="height:38px;" id="inp_ab_${this.sid}" type="button" class="modal_bt gray" value="Abort">
								<input style="height:38px;" id="inp_cnt_${this.sid}" type="button" class="modal_bt gray" value="Continue" >
							</div>
						</div>
					</div>
				</div>
			</div>`
	}
	,
	show_as_promise: function( text, name_list )
	{
		let value = "#cn_" + this.sid;
		$( value ).empty();
		$( value ).append( '<option>Please Select...</option>' );
		for( let ind in name_list )
		{
			let entry = name_list[ind];
			$( value ).append( '<option>' + entry + '</option>' );
		}
		$( value ).select( "Please Select..." );

		return new Promise(
			( resolve, reject ) =>
			{
				this.prom_resolve = resolve;
				this.prom_reject = reject;

				let value = "#cn_" + this.sid;

				$( "#getvaltxt__" ).html( text );

				$( "#diag_" + this.sid ).fadeIn();
			}
		);
	}
	,
	prom_resolve: () => { }
	,
	prom_reject: () => { }
	,
	init: function()
	{
		let _ = this;

		$( 'body' ).append( _.htmlcont() );

		let inp_cnt_id_sel = "#inp_cnt_" + _.sid;
		let inp_abort_id_sel = "#inp_ab_" + _.sid;
		let n = "#diag_" + _.sid;
		let value = "#cn_" + _.sid;


		$( inp_cnt_id_sel ).click(
			async function()
			{
				let val = $( "#cn_" + _.sid ).val();
				if( val == "Please Select..." )
					return;
				_.prom_resolve( val );
				$( "#diag_" + _.sid ).fadeOut();
			}
		);

		$( inp_abort_id_sel ).click(
			function()
			{
				_.prom_reject();
				$( n ).fadeOut();
			}
		);
	}
}

var hostname_dialog =
{
	validated: false
	,
	sid: s_id()
	,
	htmlcont: function()
	{
		return `
			<div class="modaltransparent" id="diag_${this.sid}" style="display:none;">
				<div class="modalinput3" >
					<div class="modalcentered">						
						<div id="customDiagText">
							<div id="getvaltxt" style="margin-bottom:15px;">Please enter the hostname to include</div>
							Hostname: <input type="text" class="contentfield" style="" id="cn_${this.sid}" value="" autofocus>
							<div style="position:relative;margin-top:30px;text-align:right;">
								<input style="height:38px;" id="inp_ab_${this.sid}" type="button" class="modal_bt gray" value="Cancel">
								<input style="height:38px;" id="inp_cnt_${this.sid}" type="button" class="modal_bt gray" value="Add" >
							</div>
						</div>
					</div>
				</div>
			</div>`
	}
	,
	validator_func: function() { }
	,
	show_as_promise: function( text, validator_func )
	{
		return new Promise(
			( resolve, reject ) =>
			{
				this.prom_resolve = resolve;
				this.prom_reject = reject;

				this.validated = false;
				this.validator_func = validator_func;

				let value = "#cn_" + this.sid;
				$( value ).val( "" );
				$( "#getvaltxt" ).html( text );
				document.getElementById( "cn_" + this.sid ).focus();

				$( "#diag_" + this.sid ).fadeIn();
			}
		);
	}
	,
	prom_resolve: () => { }
	,
	prom_reject: () => { }
	,
	init: function()
	{
		let _ = this;

		$( 'body' ).append( _.htmlcont() );

		let inp_cnt_id_sel = "#inp_cnt_" + _.sid;
		let inp_abort_id_sel = "#inp_ab_" + _.sid;
		let n = "#diag_" + _.sid;
		let value = "#cn_" + _.sid;

		$( inp_cnt_id_sel ).click(
			async function()
			{
				let v = await _.validate();
				if( v )
				{
					_.prom_resolve( $( "#cn_" + _.sid ).val() );
					$( "#diag_" + _.sid ).fadeOut();
				}

			}
		);

		$( inp_abort_id_sel ).click(
			function()
			{
				_.prom_reject();
				$( n ).fadeOut();
			}
		);
		$( value ).blur(
			function()
			{
				//_.validate();
			}
		);
	}
	,
	validate: async function()
	{
		let v = await this.validator_func( $( "#cn_" + this.sid ).val() );
		return v;
	}
}


var user_dialog =
{
	validated: false
	,
	sid: s_id()
	,
	htmlcont: function()
	{
		return `
			<div class="modaltransparent" id="diag_${this.sid}" style="display:none;">
				<div class="modalinput3" style="height: 240px;">
					<div class="modalcentered">						
						<div id="customDiagText">
						<div id="getvaltxt" style="margin-bottom:15px;"></div>
						User Name: <input type="text" class="contentfield" style="" id="cn_${this.sid}" value="" autofocus>
						<div class="inputitem" style="height:38px; margin-top:15px;">
                                <p class="inputlabel_single">Role </p>
                                <input type="radio" id="reader_${this.sid}" name="user_ext" value="reader" checked="checked">
                                <label for="reader">User</label><br>
								<p class="inputlabel_single">&nbsp;</p>
                                <input type="radio" id="super_${this.sid}" name="user_ext" value="super">
                                <label for="super">Super</label><br>
                                <p class="inputlabel_single">&nbsp;</p>
                                <input type="radio" id="admin_${this.sid}" name="user_ext" value="admin">
                                <label for="admin">Admin</label>
                            </div>
							<div style="position:relative;text-align:right;">
								<input style="height:38px;" id="inp_ab_${this.sid}" type="button" class="modal_bt gray" value="Cancel">
								<input style="height:38px;" id="inp_cnt_${this.sid}" type="button" class="modal_bt gray" value="Create" >
							</div>
						</div>
					</div>
				</div>
			</div>`
	}
	,
	validator_func: function() { }
	,
	show_as_promise: function( text, validator_func )
	{
		return new Promise(
			( resolve, reject ) =>
			{
				this.prom_resolve = resolve;
				this.prom_reject = reject;

				this.validated = false;
				this.validator_func = validator_func;

				let value = "#cn_" + this.sid;
				$( value ).val( "" );
				$( "#getvaltxt" ).html( text );
				document.getElementById( "cn_" + this.sid ).focus();

				$( "#diag_" + this.sid ).fadeIn();
			}
		);
	}
	,
	prom_resolve: () => { }
	,
	prom_reject: () => { }
	,
	init: function()
	{
		let _ = this;

		$( 'body' ).append( _.htmlcont() );

		let inp_cnt_id_sel = "#inp_cnt_" + _.sid;
		let inp_abort_id_sel = "#inp_ab_" + _.sid;
		let n = "#diag_" + _.sid;
		let value = "#cn_" + _.sid;

		$( inp_cnt_id_sel ).click(
			async function()
			{
				let v = await _.validate();
				if( v )
				{
					if ($( "#admin_" + _.sid).prop("checked") == true)
						var role = '", "role": "admin"}';
					else if ($( "#super_" + _.sid).prop("checked") == true)
						var role = '", "role": "super"}';
					else
						var role = '", "role": "reader"}';
					_.prom_resolve( '{"name":"' + $( "#cn_" + _.sid ).val() + role);
					$( "#diag_" + _.sid ).fadeOut();
				}

			}
		);

		$( inp_abort_id_sel ).click(
			function()
			{
				_.prom_reject();
				$( n ).fadeOut();
			}
		);
		$( value ).blur(
			function()
			{
				//_.validate();
			}
		);
	}
	,
	validate: async function()
	{
		let v = await this.validator_func( $( "#cn_" + this.sid ).val() );
		return v;
	}
}


var scriptexec_dialog =
{
	open_listener: []
	,
	close_listener: []
	,
	add_open_listener: function( fn )
	{
		this.open_listener.push( fn );
	}
	,
	add_close_listener: function( fn ) 
	{
		this.close_listener.push( fn );
	}
	,
	clear_listener: function( fn )
	{
		this.open_listener = [];
		this.close_listener = [];
	}
	,
	sid: s_id()
	,
	name: ""
	,
	jqobj: null
	,
	htmlcont: function()
	{
		return `
			<div class="modalbg" id="diag_${this.sid}" style="display:none;">
				<div class="modalmsg" id="info_${this.sid}" 
					style="width:980px;
					text-align:left;
					font-size:18px;
					line-height:24px;
					padding:1px;"
				>
				</div>
			</div>`
	}
	,
	show: function()
	{
		$( "#diag_" + this.sid ).fadeIn();
		$( "#diag_" + this.sid ).scrollTop( 0 );
		this.open_listener.forEach(
			function( fn )
			{
				fn();
			}
		);
	}
	,
	hide: function()
	{
		this.close_listener.forEach(
			function( fn )
			{
				fn();
			}
		);
		$( "#diag_" + this.sid ).fadeOut();

	}
	,
	clear_content: function()
	{
		$( "#info_" + this.sid ).empty();
	}
	,
	close_btn: function()
	{
		return `
			<div class="modalbt">
				<input style="height:38px;" type="button" class="modal_bt gray" value="Close" onclick="scriptexec_dialog.hide();">
			</div>
		`;
	}
	,
	continue_cancel_btn: function()
	{
		return `
			<div class="modalbt">
				<input style="height:38px;" type="button" class="modal_bt gray" value="Continue" onclick="scriptexec_dialog.continue();">
            <input style="height:38px;margin-left:200px;" type="button" class="modal_bt gray" value="Abort" onclick="scriptexec_dialog.abort();">
			</div>
		`;
	}
	,
	init: function()
	{
		$( 'body' ).append( this.htmlcont() );
	}
	,
	append_and_scroll: function( str_arr )
	{
		str_arr.forEach( el => $( "#info_" + this.sid ).append( el ) );
		var d = document.getElementById( "info_" + this.sid );
	}
}


var spinner =
{
	sid: s_id()
	,
	htmlcont: function()
	{
		return `
			<div class="modalbg" id="diag_${this.sid}" style="display:none;">
			<div class="modalwarningImg" style="text-align:center">
				<div class="loader"></div>
			    <div id="txt_${this.sid}"  class="modalmsg" >System busy...</div>
			</div>
			</div>
		`;
	}
	,
	show: function( t )
	{
		$( "#txt_" + this.sid ).html( t );
		$( "#diag_" + this.sid ).fadeIn();
	}
	,
	hide: function()
	{
		$( "#diag_" + this.sid ).fadeOut();
	}
	,
	init: function()
	{
		$( 'body' ).append( this.htmlcont() );
	}
}

/*
 * 
 *------------------------------------------------------------------------------
 *  
 */

function valid_container_name( n )
{
	return /^[$A-Z][0-9A-Z$]*$/i.test( n );
}


async function valid_name_and_exists( n )
{
	if( !valid_container_name( n ) )
	{
		info_dialog( "Names can only contain alphanumerical characters and cannot start with a number." )
		return false;
	}

	let cex = false;
	try
	{
		cex = await base.prom( "container_exists", [n] );
	}
	catch( err )
	{
		show_error( err );
	}

	if( !cex )
		info_dialog( "Container does not exist." )

	return cex;
}


async function valid_name_and_not_exists( n )
{
	if( !valid_container_name( n ) )
	{
		info_dialog( "Names can only contain alphanumerical characters and cannot start with a number." )
		return false;
	}

	let cnotex = false;
	try
	{
		cnotex = !await base.prom( "container_exists", [n] );
	}
	catch( err )
	{
		show_error( err );
	}

	if( !cnotex )
		info_dialog( "Container with same name exists already." )

	return cnotex;

}

/*
 * 
 *------------------------------------------------------------------------------
 *  
 */

function progress_step( current_progress, pcent_step )
{
	set_progress( current_progress );
	current_progress += pcent_step;

	if( !kill )
	{
		setTimeout( function() { progress_step( current_progress, pcent_step ); }, PROGRESS_PERIOD * 1000 );
	}
	kill = false;
}

function create_progress( duration, description )
{
	var pcent_step = PROGRESS_PERIOD * 100 / duration;
	kill = false;
	CURRENT_PROGRESS = 0;
	$( "#progressDiagText" ).text( description );
	show_progress();
	progress_step( 0, pcent_step );
}

function kill_progress()
{
	kill = true;
	hide_progress();
}



